## acl2 6.2

=== Makefile ===
# -*- mode: makefile -*-

# ACL2 Community Books Makefile
# Copyright (C) 2013 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.  You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.

##############################
### Section: Credits and History
##############################

# For many years, the ACL2 books were built using the "Makefile-generic"
# system.  This make system was written by
#
#      Matt Kaufmann <kaufmann@cs.utexas.edu> and
#      J Strother Moore <moore@cs.utexas.edu>
#
# and was actually an adaptation of Makefiles used by Bishop Brock for his IHS
# and data-structures libraries.
#
# In 2008, Sol Swords <sswords@centtech.com> developed cert.pl, a perl-based
# alternative to ACL2's make system.  This build system was largely compatible
# with the previous Makefile-generic system, but featured enhanced,
# cross-directory dependency tracking.  Centaur Technology used cert.pl for
# many years, both internally and for their publicly released "centaur/"
# community books.
#
# In 2013, Jared Davis <jared@centtech.com> developed an initial version of
# this current Makefile, which is substantially based on cert.pl, and made
# minor adjustments to several Community Books to ensure that they could all be
# certified with the new system.
#
# Subsequently, significant contributions to this Makefile have been made by
# many people, notably:
#
#   - Matt Kaufmann <kaufmann@cs.utexas.edu> has extended the Makefile in
#     support of certifying ACL2(r) books, multi-lisp compilation, provisional
#     certification, chk-include-book-worlds target, among numerous other
#     improvements and contributions such as testing the Makefile on many
#     systems and further tweaking some Community Books.
#
#   - Sol Swords <sswords@cs.utexas.edu> has provided significant support for
#     cert.pl, notably extending it to operate on Windows, and adding features
#     such as automatically tracking books that rely on ACL2(h).
#
#   - David Rager <ragerdl@cs.utexas.edu> provided significant early beta
#     testing and worked to ensure the Makefile works with ACL2(p) and in
#     different configurations of ACL2_CUSTOMIZATION; he has also provided
#     useful make targets.
#
#   - Jared Davis <jared@centtech.com> has made other miscellaneous
#     improvements, e.g., a more comprehensive implementation of book cleaning.

##############################
### Section: Documentation
##############################

# Basic usage:
#    make -j <jobs> [<target>]
#
# Where:
#    - <jobs> is how many books you want to certify in parallel,
#        typically the number of cores on your machine
#    - <target> is optional and defaults to "all" when omitted,
#        or names the target you want to build (see below).

# Major top-level targets:
#   - `all' is the default
#   - `everything' includes everything in `all' and also some slow books

# Major user-definable variables (whose effects occur in this order):
#   - ACL2
#     ACL2 executable, which is "acl2" by default.
#   - STARTJOB
#     The shell, which is the path to "bash" by default.
#   - NO_RESCAN
#     When defined, avoids rebuilding auxiliary files of targets and
#     dependencies.
#   - ACL2_COMP
#     When defined, causes multi-lisp compilation (most users won't
#     care about this one)
#   - EXCLUDED_PREFIXES
#     Reduces the default targets by eliminating all that start with
#     any prefix in this list of strings.
#   - ACL2_BOOK_CERTS
#     Augments the targets with this list of strings, e.g., foo.cert.
#   - ACL2_BOOK_DIRS
#     Augments the targets with all targets that have a prefix among
#     this list of strings.

# Jared Davis has summarized the improvements over the earlier
# Makefile as follows.

#  - It simplifies the build system, doing away with hundreds of Makefiles in
#    individual directories, and replacing them with this single file.  This is
#    possible because I've gone through and fixed up many books so that they
#    follow certain conventions, explained below.
#
#  - It increases (significantly) opportunities for book-level parallelism, by
#    doing away with directory-level dependencies.  Essentially, any books that
#    do not have an include-book dependency can be built in parallel.  At the
#    same time, this means that books can be reorganized based on their logical
#    content, without regards to directory build order.
#
#  - It generally increases build-system automation.  We use "find" commands to
#    find Lisp files instead of maintaining (by hand) lists of directories.  We
#    also do not need to manually keep track of dependencies between
#    directories, etc.
#
# This Makefile starts by automatically scanning for books and their
# dependencies.  This scanning can be slightly expensive, especially on slow
# NFS systems.  When you know that you haven't added or changed any books, you
# might prefer to avoid rescanning by adding NO_RESCAN=1 to the command line.
#
# In order to make the book- and dependency-scanning simple and reliable, books
# are expected to follow certain conventions.  These conventions are generally
# very similar to the previous behavior of cert.pl and Makefile-generic.
#
#   - We scan for lines like (include-book "foo") and (ld "foo.lisp"); for
#     dependency scanning to work, these commands must be on a single line and
#     can't be wrapped up in macros.  Occasionally it is useful to fool the
#     dependency scanner, e.g., in a multi-line comments you might do:
#
#        #| Here's an example of how to use this stuff:
#
#           (include-book ;; newline to fool dependency scanner
#             "foo")
#
#           (demo-of-how-to-use-foo)
#        |#
#
#   - Additional dependencies (e.g., on raw-lisp files or other kinds of data
#     files) can be added using depends-on comments, e.g.,
#
#        ; (depends-on "foo-raw.lsp")
#
#   - Certifiable books should be named foo.lisp
#   - Non-certifiable Lisp files should be named foo.lsp
#   - The instructions for certifying foo.lisp are found in:
#       foo.acl2, if it exists, or else
#       cert.acl2, if it exists, or else
#       default to simply (certify-book "foo" ? t)
#     These instructions specify arguments to certify-book, for example:
#       ; cert-flags: ? t :ttags :all
#   - Books that depend on ACL2(h), such as centaur/tutorial/alu16-book.lisp,
#     contain this line (or, a cert_param directive can be in the
#     .acl2 file that is consulted, as discussed above):
#       ; cert_param: (hons-only)
#   - Two-pass certification is handled as follows, for example in
#     books/make-event/stobj-test.acl2 (as indicated above, this can
#     also go into the book instead of the relevant .acl2 file):
#       ; cert_param: (acl2x)
#   - It's not clear that provisional certification is fully
#     supported.  For now, we implement it for two specific
#     directories; search below for "provisional certification" to see
#     how that's done.
#   - The "user" target allows one to restrict to specific
#     directories.  Search for "user" below to see an example.
#
# CHANGE/BOZO: In this Makefile (as in cert.pl), any certify-book lines given
# in the .acl2 file are ignored.  Instead, we generate the certify-book command
# to use by looking for comments like:
#
#         ; cert-flags: ? t :ttags :all
#
# These comments can be put in the individual foo.acl2 or (for directory-level
# defaults) in cert.acl2.  The default cert-flags are "? t".  Using special
# comments instead of certify-book forms means that the certification flags
# can't be hidden inside macros, possibly easing the job of an "evaluator."
#
# BOZO (from Jared) I have gone through the ACL2 regression suite and replaced
# certify-book lines throughout .acl2 files with cert-flags comments.  However,
# for now I've left the certify-book commands intact, for compatiblity with
# Makefile-generic.  Eventually, we should not have both things in .acl2 files.
# Before we can do that, we'll need to change Makefile-generic to look for
# cert-flags instead of certify-book commands.  Alternately, maybe the scheme
# should be something like: if you give a certify-book command, we use it;
# otherwise we generate one using the cert-flags.


# STATUS / TODO LIST / MISSING FEATURES / BOZOS:
#
#  [DONE] Requires perl on the client machine (I think we've agreed this is
#         okay)
#
#  [DONE] Two-pass certification seems to work, using the cert.pl directive
#         cert_param(acl2x).  See for instance
#         books/make-event/stobj-test.acl2.
#
#  [DONE] How should cleaning work?
#
#    Using a find command has the advantage that it will get rid of old files
#    even after the .lisp files have been deleted.  It has the disadvantage
#    that it seems tricky to properly delete .h and .c files using a find
#    command.  An alternative would be to use CERT_PL_CERTS to generate a huge
#    list of files to remove.  This will require using xargs, etc., which is
#    gross, but so does the find command.  Blah.
#
#    We now implement the CERT_PL_CERTS-based approach, but using clean.pl,
#    which nicely deals with the whole too-many-arguments issue.  It seems to
#    perform well.  I think this is probably as good as we can do.

##############################
### Section: Preliminaries
##############################

ifneq ($(ACL2_JOBS), )
$(error Error: variable ACL2_JOBS is obsolete (use -j instead); see :DOC book-makefiles)
endif # ifneq ($(ACL2_JOBS), )

ACL2 ?= acl2

SHELL := $(shell which bash)
STARTJOB ?= $(SHELL)

.SUFFIXES:
.SUFFIXES: .cert .lisp

# Keep this .PHONY target here, even though the main target
# definitions come much later in the file, because we start defining
# the "all" target (at least) well before then.  Also, keep "all:"
# here so that "all" is the top target.
.PHONY: all everything
all:

##############################
### Section: Create auxiliary files (Makefile-xxx) and initial OK_CERTS
##############################

# It seems that info is defined starting in GNU make version 3.81.
# But version 3.80 seems to tolerate calls of info, simply ignoring
# them.  We could use a variable, as follows, so that you can set
# INFO=warning on the command line if you want to see the messages
# even with GNU make version 3.80.  But maybe this is too ugly, so we
# just leave the idea as a comment.
## INFO := info
### Example: Prints something like "Makefile:227: just a test" when
### invoked with INFO=warning; otherwise, same as $(info just a test).
## $(eval $$($(INFO) just a test))

ifndef NO_RESCAN

# In the following, we exclude centaur/quicklisp explicitly rather
# than using the usual cert_pl_exclude file, because centaur/quicklisp
# uses cert.pl to certify books.  We exclude centaur/quicklisp
# explicitly since when we do want to make it, it will use cert.pl and
# hence we can't put a cert_pl_exclude file in that directory.  Some
# others we exclude because there are subdirectories and it's simply
# easiest to stop at the root.
$(info Scanning for books...)
REBUILD_MAKEFILE_BOOKS := $(shell \
  rm -f Makefile-books; \
  time find . -name "*.lisp" \

=== centaur/quicklisp/Makefile ===
# Quicklisp setup for Centaur books
# Copyright (C) 2008-2012 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.  This program is distributed in the hope that it will be useful but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
# more details.  You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
#
# Original author: Jared Davis <jared@centtech.com>

STARTJOB ?= $(SHELL)
ACL2 ?= acl2

all: top.cert

quicklisp.lisp:
	curl -O http://beta.quicklisp.org/quicklisp.lisp

setup.lisp: quicklisp.lisp install.lsp
	$(STARTJOB) -c "$(ACL2) < install.lsp &> install.out"

clean:
	rm -rf setup.lisp quicklisp.lisp asdf.lisp cache dists local-projects \
	       tmp install.out quicklisp *.cert.out *.cert.time *.lx64fsl \
               Makefile-tmp *.cert

top.cert: setup.lisp
	cert.pl top.cert

=== centaur/vl/Makefile ===
# ACL2 ?= ../../acl2/saved_acl2
# include ../../acl2/books/Makefile-generic
#
# # Dependencies:
#
# BOOKS := $(filter-out acl2-customization,$(BOOKS))
# ACL2_COMPILE_FLG := t :ttags :all :skip-proofs-okp t
#
# LISPFILES = $(wildcard *.lisp)
# LSPFILES = $(wildcard *.lsp)
# ACL2FILES = $(wildcard *.acl2)
#
# TAGS: $(LISPFILES)
# 	etags *.lisp
#
# -include Makefile-deps


.PHONY: all full clean TAGS

all:
	@echo "Use cert.pl to build"
	@echo "Or use 'make full', which runs 'cert.pl -j 8' to build VL."
	@echo ""

allbooks:
	cert.pl -j 8 top.cert lint/lint.cert

full: allbooks

TAGS:
	@echo "Building TAGS"
	etags `find . -name "*.lisp"` `find . -name "*.lsp"` `find . -name "*.acl2"`

CLEANFILES := *.cert *.lx64fsl *.out *.time *~

clean:
	rm -f $(CLEANFILES) TAGS 
	cd loader; rm -f $(CLEANFILES)
	cd util; rm -f $(CLEANFILES)
	cd transforms; rm -f $(CLEANFILES)
	cd transforms/occform; rm -f $(CLEANFILES)
	cd checkers; rm -f $(CLEANFILES)
	cd mlib; rm -f $(CLEANFILES)
	cd lint -f $(CLEANFILES)

=== debian/changelog ===
acl2 (6.2-6) unstable; urgency=low

  * fix elementary-bounders.acl2

 -- Camm Maguire <camm@debian.org>  Mon, 29 Jul 2013 18:54:53 +0000

acl2 (6.2-5) unstable; urgency=low

  * (setq si::*optimize-maximum-pages* nil) in elementary-bounders.acl2
  * build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Sat, 27 Jul 2013 12:49:46 +0000

acl2 (6.2-4) unstable; urgency=low

  * build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 23 Jul 2013 18:11:51 +0000

acl2 (6.2-3) unstable; urgency=low

  * build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Sat, 20 Jul 2013 02:21:17 +0000

acl2 (6.2-2) unstable; urgency=low

  * Add (in-package :acl2) preceeding save-exec in final cert image
    modification stage to support #-native-reloc targets

 -- Camm Maguire <camm@debian.org>  Mon, 15 Jul 2013 16:34:41 +0000

acl2 (6.2-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Thu, 11 Jul 2013 22:02:56 +0000

acl2 (6.1-6) unstable; urgency=low

  * build-dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Tue, 02 Jul 2013 16:10:25 +0000

acl2 (6.1-5) unstable; urgency=low

  * reinstate skipped books and build depend on latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 21 Jun 2013 23:14:46 +0000

acl2 (6.1-4) unstable; urgency=low

  * skip books/centaur/vl/transforms/xf-sizing.lisp, which takes too much memory

 -- Camm Maguire <camm@debian.org>  Sun, 26 May 2013 03:50:49 +0000

acl2 (6.1-3) unstable; urgency=low

  * skip books/centaur/defrstobj/basic-tests.lisp, which takes too much memory

 -- Camm Maguire <camm@debian.org>  Thu, 23 May 2013 13:20:29 +0000

acl2 (6.1-2) unstable; urgency=low

  * skip elementary-bounders.lisp certification, which takes too much memory

 -- Camm Maguire <camm@debian.org>  Tue, 21 May 2013 17:15:51 +0000

acl2 (6.1-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Tue, 23 Apr 2013 14:52:39 +0000

acl2 (6.0-3) unstable; urgency=low

  * Lintian cleanups
  * certify centaur books with memory adjustments (lint.acl2, top.acl2)

 -- Camm Maguire <camm@debian.org>  Thu, 17 Jan 2013 23:12:05 +0000

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: gcl ( >= 2.6.7+dfsga-37 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common
Standards-Version: 3.9.4

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: acl2-emacs
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary. 

Package: acl2-source
Architecture: all
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}	  
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: acl2-emacs
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs24 | emacsen, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Conflicts: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. 
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

books/workshops:
	mkdir $@

#init.lsp.ori: 
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori 

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

saved_acl2: $(DLOPEN_T) #debian/patches_applied 
#	echo '(progn (load "debian/sublis_patch.lsp")(si::save-system "pgcl"))' | gcl
	gcl -batch -eval "(bye #-native-reloc 1)" || \
		(gcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
	gcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) LISP=gcl
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	$(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	$(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME="/tmp/" \
	$(MAKE) certify-books >$@ 2>&1 & j=$$! ; \
	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \
	wait $$j
	[ -f $@ ] && ! fgrep '**' $@ || echo FULL TEST FAILS
	for i in $$(find books -name "*.out"); do \
		if ! [ -e $${i%out}cert ] ; then \
			echo $$i ; \
			cat $$i ; \
		fi ; \
	done
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ! fgrep '**' $@

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && make -f Makefile compile 
	cd books/interface/infix && make -f Makefile example 
#	cd books/interface/infix && make -f Makefile events 
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME="/tmp/" $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp 
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied: 
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-emacs acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

clean: books/workshops infix_clean #debian/patches_unapplied
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	$(MAKE) clean
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2
	for i in data c h ; do \
		for j in $$(find -name "*.$$i") ; do\
			k=$$(echo $$j | sed "s,\.$$i$$,,1") ;\
			! [ -e $$k.lisp ] || rm $$j ; \
		done ; \
	done
	rm -f books/bdd/benchmarks.data acl2r.lisp tmp
	rmdir $<
	rm -f debian/dpatches $(INSTALLS) $(LINKS) debian/README.Debian saved_acl2*
	rm -f debian/dlopen.lisp debian/acl2-emacs.emacsen-startup
	rm -f debian/acl2.sh pgcl books/Makefile-tmp books/coi/gensym/gensym.out
	rm -f books/coi/gensym/Makefile-deps books/coi/gensym/workxxx.gensym
	rm -rf doc/HTML-old doc/EMACS-old doc/acl2-wc.txt
	rm -f books/centaur/bitops/bitsets-opt-raw.o books/centaur/vl/util/gc-raw.o \
		books/centaur/misc/tshell-raw.o books/centaur/vl/Makefile-tmp
	dh_clean -XTAGS

debian/acl2-infix.install:: 
	find books/interface/infix -name "*.o" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@
	find books/interface/infix -name "*.sty" | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/texmf/tex/latex\n",$$1);}' >>$@

debian/acl2-infix-source.install:: 
	find books/interface/infix -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-emacs.install:: 
	find books/interface/emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@
	find emacs -name "*.el" | awk '{printf("%s usr/share/emacs/site-lisp/$(PN)\n",$$1);}' >>$@

debian/acl2.install:: 
	echo debian/acl2.sh usr/bin >>$@
	echo saved_acl2 usr/lib/$(PD) >>$@

debian/acl2-books.install:: 
	find books -name "*.o" | grep -v interface/ | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/lib/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-source.install:: 
	find * -name "*.lisp" -maxdepth 0 | grep -v TMP1.lisp | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >$@
	find * -name "TAGS" -maxdepth 0 | awk '{printf("%s usr/share/$(PD)\n",$$1);}' >>$@

debian/acl2-books-certs.install:: 
	find books -name "*.cert" | grep -v fix-cert/moved | grep -v system/pcert | \
		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s.final usr/share/$(PD)/%s\n",$$1,a);}' >>$@
	find books -name "*.pcert0.final" | \
		awk '{a=$$1;sub(".pcert0.final",".cert",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

debian/acl2-books-source.install:: 
	find books -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

## acl2 6.3

=== Makefile ===
--- 
+++ 
@@ -76,6 +76,10 @@
 #        typically the number of cores on your machine
 #    - <target> is optional and defaults to "all" when omitted,
 #        or names the target you want to build (see below).
+
+# Of course, the usual GNU make options are available.  In particular,
+# -k is useful for causing make to keep going when an error is
+# encountered (but return a non-zero error status at the end).
 
 # Major top-level targets:
 #   - `all' is the default
@@ -100,6 +104,10 @@
 #   - ACL2_BOOK_DIRS
 #     Augments the targets with all targets that have a prefix among
 #     this list of strings.
+#   - USE_QUICKLISP
+#     Set this if you want to build Quicklisp (which is sort of like
+#     CPAN or RubyGems but for Lisp).  Required for certain books in
+#     oslib.
 
 # Jared Davis has summarized the improvements over the earlier
 # Makefile as follows.
@@ -155,10 +163,18 @@
 #       default to simply (certify-book "foo" ? t)
 #     These instructions specify arguments to certify-book, for example:
 #       ; cert-flags: ? t :ttags :all
-#   - Books that depend on ACL2(h), such as centaur/tutorial/alu16-book.lisp,
-#     contain this line (or, a cert_param directive can be in the
-#     .acl2 file that is consulted, as discussed above):
-#       ; cert_param: (hons-only)
+#   - In the following cases, books may be skipped in which case,
+#     recursively, so are books that include such books, books that
+#     include those parent books, and so on.  In each case, the
+#     indicated line may be placed either in the .lisp file or in the
+#     .acl2 file that is consulted, as discussed above.
+#       - Books that depend on ACL2(h), such as
+#         centaur/tutorial/alu16-book.lisp, contain this line:
+#           ; cert_param: (hons-only)
+#       - Books that require glucose (a SAT solver) contain this line:
+#           ; cert_param: (uses-glucose)
+#       - Books that require quicklisp contain this line:
+#           ; cert_param: (uses-quicklisp)
 #   - Two-pass certification is handled as follows, for example in
 #     books/make-event/stobj-test.acl2 (as indicated above, this can
 #     also go into the book instead of the relevant .acl2 file):
@@ -190,6 +206,18 @@
 # should be something like: if you give a certify-book command, we use it;
 # otherwise we generate one using the cert-flags.
 
+# BUILDING THE XDOC MANUAL
+
+# The xdoc manual is built in centaur/manual/, top page index.html, as
+# a byproduct of building centaur/doc.cert with ACL2(h) using
+# USE_QUICKLISP=1 on the `make' command line.  This has been tested
+# using CCL on Linux, but may work for other OS/Lisp combinations.
+# See also centaur/README.html.  ACL2(h) is required for that build of
+# the xdoc manual, because it is required for some of the books
+# included in centaur/doc.lisp.  You can create a manual for your own
+# books using ACL2 or ACL2(h); see topic SAVE (parent topic XDOC) in
+# the xdoc manual, either in centaur/manual/ or on the web at
+# http://fv.centtech.com/acl2/latest/doc/.
 
 # STATUS / TODO LIST / MISSING FEATURES / BOZOS:
 #
@@ -218,7 +246,7 @@
 ##############################
 
 ifneq ($(ACL2_JOBS), )
-$(error Error: variable ACL2_JOBS is obsolete (use -j instead); see :DOC book-makefiles)
+${error Error: variable ACL2_JOBS is obsolete -- use -j instead -- see :DOC book-makefiles }
 endif # ifneq ($(ACL2_JOBS), )
 
 ACL2 ?= acl2
@@ -231,36 +259,3 @@
 
 # Keep this .PHONY target here, even though the main target
 # definitions come much later in the file, because we start defining
-# the "all" target (at least) well before then.  Also, keep "all:"
-# here so that "all" is the top target.
-.PHONY: all everything
-all:
-
-##############################
-### Section: Create auxiliary files (Makefile-xxx) and initial OK_CERTS
-##############################
-
-# It seems that info is defined starting in GNU make version 3.81.
-# But version 3.80 seems to tolerate calls of info, simply ignoring
-# them.  We could use a variable, as follows, so that you can set
-# INFO=warning on the command line if you want to see the messages
-# even with GNU make version 3.80.  But maybe this is too ugly, so we
-# just leave the idea as a comment.
-## INFO := info
-### Example: Prints something like "Makefile:227: just a test" when
-### invoked with INFO=warning; otherwise, same as $(info just a test).
-## $(eval $$($(INFO) just a test))
-
-ifndef NO_RESCAN
-
-# In the following, we exclude centaur/quicklisp explicitly rather
-# than using the usual cert_pl_exclude file, because centaur/quicklisp
-# uses cert.pl to certify books.  We exclude centaur/quicklisp
-# explicitly since when we do want to make it, it will use cert.pl and
-# hence we can't put a cert_pl_exclude file in that directory.  Some
-# others we exclude because there are subdirectories and it's simply
-# easiest to stop at the root.
-$(info Scanning for books...)
-REBUILD_MAKEFILE_BOOKS := $(shell \
-  rm -f Makefile-books; \
-  time find . -name "*.lisp" \

=== add-ons/Makefile ===
include ../Makefile-generic

-include Makefile-deps

=== arithmetic-2/Makefile ===
DIRS = pass1 meta floor-mod
include ../Makefile-subdirs

=== arithmetic-3/Makefile ===
arith-top: top all
all: top

DIRS = pass1 bind-free floor-mod
include ../Makefile-subdirs
include ../Makefile-generic

# top.cert: top.lisp
# top.cert: bind-free/top.cert
# top.cert: floor-mod/floor-mod.cert
# top.cert: floor-mod/mod-expt-fast.cert

-include Makefile-deps

=== arithmetic-5/Makefile ===
arith-top: top all
all: top

DIRS = support lib
include ../Makefile-subdirs
include ../Makefile-generic

-include Makefile-deps

=== arithmetic/Makefile ===
include ../Makefile-generic
-include Makefile-deps

# Unfortunately, we cannot certify top-with-meta until we have completed
# certification in the meta/ directory.  So we set BOOKS so that
# top-with-meta.cert is not made by default.  The ":=" makes the assignment
# non-recursive.

BOOKS := $(filter-out top-with-meta,$(BOOKS))

# Extra deps for top-with-meta because of circularity with meta directory.
# Messy messy.

top-with-meta.cert: top-with-meta.lisp
top-with-meta.cert: top.cert
top-with-meta.cert: ../meta/meta.cert
# DEPENDENCIES FOR PROVISIONAL CERTIFICATION ONLY:
ifneq ($(ACL2_PCERT),)
top-with-meta.pcert: top-with-meta.acl2x
top-with-meta.acl2x: top-with-meta.lisp
top-with-meta.acl2x: top.acl2x
top-with-meta.acl2x: ../meta/meta.acl2x
top-with-meta.cert: top-with-meta.pcert
endif

=== bdd/Makefile ===
include ../Makefile-generic

BOOKS = $(patsubst %.lisp, %, $(wildcard *.lisp)) benchmarks

clean: clean-benchmarks

clean-benchmarks:
	rm -f benchmarks.lisp

benchmarks.lisp: cbf.cert

# Below is the result of running 'make dependencies' after executing
# "make ACL2_PCERT=".  If we run 'make dependencies' before creating
# benchmarks.lisp, we get some unfortunate error ourput.  So, we avoid
# using the usual -include of Makefile-deps.

alu-proofs.cert: alu-proofs.lisp
alu-proofs.cert: alu.cert

alu.cert: alu.lisp
alu.cert: bdd-primitives.cert

bdd-primitives.cert: bdd-primitives.lisp

benchmarks.cert: benchmarks.lisp
benchmarks.cert: bool-ops.cert
benchmarks.cert: benchmarks.acl2
benchmarks.cert: cbf.cert

bool-ops.cert: bool-ops.lisp

cbf.cert: cbf.lisp
cbf.cert: bool-ops.cert

hamming.cert: hamming.lisp
hamming.cert: bdd-primitives.cert

pg-theory.cert: pg-theory.lisp
pg-theory.cert: bdd-primitives.cert

# DEPENDENCIES FOR PROVISIONAL CERTIFICATION ONLY:
ifneq ($(ACL2_PCERT),)

# Dependencies for .pcert files:

alu-proofs.pcert: alu-proofs.acl2x

alu.pcert: alu.acl2x

bdd-primitives.pcert: bdd-primitives.acl2x

benchmarks.pcert: benchmarks.acl2x
benchmarks.pcert: benchmarks.acl2

bool-ops.pcert: bool-ops.acl2x

cbf.pcert: cbf.acl2x

hamming.pcert: hamming.acl2x

pg-theory.pcert: pg-theory.acl2x

benchmarks.pcert: benchmarks.acl2x
benchmarks.pcert: benchmarks.acl2

# Dependencies for .acl2x files (similar to those for .cert files):

alu-proofs.acl2x: alu-proofs.lisp
alu-proofs.acl2x: alu.acl2x

alu.acl2x: alu.lisp
alu.acl2x: bdd-primitives.acl2x

bdd-primitives.acl2x: bdd-primitives.lisp

benchmarks.acl2x: benchmarks.lisp
benchmarks.acl2x: bool-ops.acl2x
benchmarks.acl2x: benchmarks.acl2
benchmarks.acl2x: cbf.acl2x

bool-ops.acl2x: bool-ops.lisp

cbf.acl2x: cbf.lisp
cbf.acl2x: bool-ops.acl2x

hamming.acl2x: hamming.lisp
hamming.acl2x: bdd-primitives.acl2x

pg-theory.acl2x: pg-theory.lisp
pg-theory.acl2x: bdd-primitives.acl2x

benchmarks.acl2x: benchmarks.lisp
benchmarks.acl2x: bool-ops.acl2x
benchmarks.acl2x: benchmarks.acl2
benchmarks.acl2x: cbf.acl2x

# Dependencies for converting .pcert to .cert files:

alu-proofs.cert: alu-proofs.pcert
alu.cert: alu.pcert
bdd-primitives.cert: bdd-primitives.pcert
benchmarks.cert: benchmarks.pcert
bool-ops.cert: bool-ops.pcert
cbf.cert: cbf.pcert
hamming.cert: hamming.pcert
pg-theory.cert: pg-theory.pcert
benchmarks.cert: benchmarks.pcert

endif

=== cgen/Makefile ===
ACL2_COMPILE_FLG := t :ttags :all
include ../Makefile-generic
-include Makefile-deps

=== clause-processors/Makefile ===
cl-proc-top: top1 all
all: top1

# We avoid going into SULFA if the appropriate tool is not present.  The
# following is based on target "top" from ../Makefile-subdirs.

# Keep the minisat path below in sync with the definition of SAT_SOLVER in
# SULFA/Makefile.
.PHONY: top1
top1:
	@if [ -f ${PWD}/../../aux/minisat2/${HOSTTYPE}/minisat/core/minisat ] ; \
	then \
	(cd SULFA ; $(MAKE)) ; \
	my_status=$$? ; \
	if [ $$my_status -ne 0 ] ; then exit 1 ; fi ; \
	else \
	echo "*NOTE*: Skipping SULFA subdirectory (no SAT solver installed; see SULFA/README)." ; \
	fi
	@exit $$my_status

# Note that the call of $(MAKE) in support of target top1, above, deals with
# the SULFA directory.  It is tempting to include the Makefile-subdirs line in
# order to deal with compilation targets, e.g., supporting "make all-o" from
# the main books/ directory.  But some systems may skip certification of books
# under the SULFA directory.  Feel free to uncomment the Makefile-subdirs lines
# if you know that those books will be certified.  At any rate, we extend the
# clean target below to clean the SULFA directories whether or not the
# Makefile-subdirs line is uncommented.
DIRS = SULFA/books SULFA/c-files SULFA/scripts
# include ../Makefile-subdirs
include ../Makefile-generic

# Keep the following two targets, clean and clean-sulfa, in sync with the
# definitions of clean and clean-more in ../Makefile-subdirs above.  If the
# Makefile-subdirs line is uncommented above then the SULFA books will be
# cleaned twice, but there's no harm in that.

.PHONY: clean
clean: clean-sulfa

.PHONY: clean-sulfa
clean-sulfa:
	@for dir in $(DIRS) ; \
	do \
	if [ -f $$dir/Makefile ]; then \
	(cd $$dir ; \
	$(MAKE) clean ; \
	cd ..) ; \
	fi \
	done

# Dependencies:

-include Makefile-deps

=== coi/Makefile ===
DIRS =	symbol-fns \
	util \
	adviser \
	nary \
	lists \
	osets \
	syntax \
	bags \
	alists \
	records \
	records/fast \
	paths \
	maps \
	dtrees \
	defpun \
	defstructure \
	super-ihs \
	gacc \
	gensym \
        generalize \
	quantification \
	termination

include ../Makefile-subdirs

=== cutil/Makefile ===
include ../Makefile-generic
-include Makefile-deps

.PHONY: moreclean
moreclean:
	rm -rf *.time

clean: moreclean

=== defexec/Makefile ===
DIRS = ordinals dag-unification reflexive defpun-exec find-path/graph find-path other-apps
include ../Makefile-psubdirs

# Because find-path/Makefile has the dependency
# fpst.cert: graph/linear-find-path.cert
# we add the following:
find-path: find-path/graph

=== debian/changelog ===
acl2 (6.3-5) unstable; urgency=low

  * rebuild against latest gcl

 -- Camm Maguire <camm@debian.org>  Fri, 18 Oct 2013 16:10:57 +0000

acl2 (6.3-4) unstable; urgency=low

  * set HOME for mini-proveall make

 -- Camm Maguire <camm@debian.org>  Tue, 15 Oct 2013 14:12:15 +0000

acl2 (6.3-3) unstable; urgency=low

  * set HOME to $(pwd)

 -- Camm Maguire <camm@debian.org>  Mon, 14 Oct 2013 15:09:48 +0000

acl2 (6.3-2) unstable; urgency=low

  * build dep against latest gcl

 -- Camm Maguire <camm@debian.org>  Sat, 12 Oct 2013 01:46:31 +0000

acl2 (6.3-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Wed, 02 Oct 2013 20:19:51 +0000

acl2 (6.2-8) unstable; urgency=low

  * Allow certification failures for 1) dlopen machines, as we cannot
    control the surpassed 1024 maximum dlopen limit, and 2) machines with
    an insufficient hard limit on data segment size (e.g. kfreebsd-i386, or any
    machine which cannot brk 1Gb).
  * add build-dep on texinfo
  * add upstream certificate relocation patch to other-events.lisp

 -- Camm Maguire <camm@debian.org>  Mon, 09 Sep 2013 15:27:04 +0000

acl2 (6.2-7) unstable; urgency=low

  * build-dep against latest gcl
  * again allow optimize-maximum-pages in elementary-bounders.acl2

 -- Camm Maguire <camm@debian.org>  Tue, 06 Aug 2013 11:30:55 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: math
 Priority: optional
 Maintainer: Camm Maguire <camm@debian.org>
-Build-Depends: gcl ( >= 2.6.7+dfsga-37 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common
+Build-Depends: gcl ( >= 2.6.9-12 ), libgmp3-dev, libreadline-dev, emacs24 | emacsen, debhelper ( >= 5 ), texlive-latex-recommended, libxmu-dev, libxaw7-dev, time, tex-common, texinfo
 Standards-Version: 3.9.4
 
 Package: acl2

=== debian/rules ===
--- 
+++ 
@@ -71,23 +71,25 @@
 	mv $@.gcl $@
 
 debian/mini-proveall.out: saved_acl2
-	$(MAKE) mini-proveall
+	HOME=$$(pwd) $(MAKE) mini-proveall
 	mv $(@F) $@
 
 books/short-test.log: saved_acl2.c
 	cp saved_acl2 saved_acl2.ori
-	$(MAKE) certify-books-short
+	HOME=$$(pwd) $(MAKE) certify-books-short
 	cp saved_acl2.ori saved_acl2
+
+#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \
 
 debian/test.log: saved_acl2.c
 	mv saved_acl2 saved_acl2.ori
 	cp $< saved_acl2
 	BUILDDIR="$$(dirname $$(pwd))" \
 	FINALDIR="/usr/share/$(PD)" \
-	HOME="/tmp/" \
+	HOME=$$(pwd) \
 	$(MAKE) certify-books >$@ 2>&1 & j=$$! ; \
-	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \
-	wait $$j
+	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$! ; \
+	wait $$j ; kill $$k $$l
 	[ -f $@ ] && ! fgrep '**' $@ || echo FULL TEST FAILS
 	for i in $$(find books -name "*.out"); do \
 		if ! [ -e $${i%out}cert ] ; then \
@@ -96,7 +98,9 @@
 		fi ; \
 	done
 	mv saved_acl2.ori saved_acl2
-	[ -f $@ ] && ! fgrep '**' $@
+	[ -f $@ ] && ( ! fgrep '**' $@ || \
+	  gcl -batch -eval "(bye #+native-reloc 1)" || \
+	  [ $$(ulimit -d -H | sed 's,unlimited,1000000,g') -lt 1000000 ] )
 
 books/interface/infix/Makefile: books/interface/infix/makefile
 	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
@@ -109,7 +113,7 @@
 	touch $@
 
 doc/TEX/acl2-book.ps.gz: saved_acl2
-	HOME="/tmp/" $(MAKE) DOC
+	HOME=$$(pwd) $(MAKE) DOC
 	rm -f doc/HTML/LICENSE
 	find doc -empty -exec rm {} \;
 
@@ -217,7 +221,3 @@
 	find books -name "*.cert" | grep -v fix-cert/moved | grep -v system/pcert | \
 		awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s.final usr/share/$(PD)/%s\n",$$1,a);}' >>$@
 	find books -name "*.pcert0.final" | \
-		awk '{a=$$1;sub(".pcert0.final",".cert",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@
-
-debian/acl2-books-source.install:: 
-	find books -name "*.lisp" | awk '{a=$$1;sub("/[^/]*$$","",a);printf("%s usr/share/$(PD)/%s\n",$$1,a);}' >>$@

=== debian/watch ===
version=2
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
opts=pasv ftp://ftp.cs.utexas.edu/pub/moore/acl2/	acl2-([0-9.]*)\.tar\.gz	debian	uupdate
